Index: src/wp-includes/date.php
===================================================================
--- src/wp-includes/date.php	(revision 25535)
+++ src/wp-includes/date.php	(working copy)
@@ -74,10 +74,70 @@
 	public $compare = '=';
 
 	/**
-	 * Constructor
+	 * Constructor.
 	 *
-	 * @param array $date_query A date query parameter array, see class descriptor for further details.
-	 * @param array (optional) $default_column What column name to query against. Defaults to "post_date".
+	 * @param array $date_query {
+	 *     One or more associative arrays of date query parameters.
+	 *
+	 *     @type array {
+	 *         @type string 'column'   Optional. The column to query against.
+	 *                                 Default 'post_date'. Accepts 'post_date', 'post_date_gmt', 'post_modified',
+	 *                                 'post_modified_gmt', 'comment_date', 'comment_date_gmt'.
+	 *         @type string 'compare'  Optional. The comparison operator.
+	 *                                 Default '='. Accepts '=', '!=', '>', '>=', '<', '<=', 'IN', 'NOT IN',
+	 *                                 'BETWEEN', 'NOT BETWEEN'.
+	 *         @type string 'relation' Optional. The boolean relationship between the date queryies.
+	 *                                 Default 'OR'. Accepts 'OR', 'AND'.
+	 *         @type array {
+	 *             @type string|array 'before' {
+	 *                 Optional. Date to retrieve posts before.
+	 *                 Accepts strtotime()-compatible string, or array of 'year', 'month', 'day' values.
+	 *
+	 *                 @type string 'year'  The four-digit year.
+	 *                                      Default empty. Accepts any four-digit year.
+	 *                 @type string 'month' The month of the year.
+	 *                                      Default empty. Accepts numbers 1-12.
+	 *                 @type string 'day'   The day of the month.
+	 *                                      Default empty. Accepts numbers 1-31.
+	 *             }
+	 *             @type string|array 'after' {
+	 *                 Optional. Date to retrieve posts after.
+	 *                 Accepts strtotime()-compatible string, or array of 'year', 'month', 'day' values.
+	 *
+	 *                 @type string 'year'  The four-digit year.
+	 *                                      Default empty. Accepts any four-digit year.
+	 *                 @type string 'month' The month of the year.
+	 *                                      Default empty. Accepts numbers 1-12.
+	 *                 @type string 'day'   The day of the month.
+	 *                                      Default empty. Accepts numbers 1-31.
+	 *             }
+	 *             @type string       'column'    Optional. The column to query against.
+	 *                                            Default 'post_date'. Accepts 'post_date', 'post_date_gmt', 'post_modified',
+	 *                                            'post_modified_gmt', 'comment_date', 'comment_date_gmt'.
+	 *             @type string       'compare'   Optional. The comparison operator.
+	 *                                            Default '='. Accepts '=', '!=', '>', '>=', '<', '<=', 'IN', 'NOT IN',
+	 *                                            'BETWEEN', 'NOT BETWEEN'.
+	 *             @type bool         'inclusive' Optional. Whether the exact difference between the 'before' and 'after' dates should be matched or not.
+	 *                                            Default. Accepts.
+	 *             @type int          'year'      Optional. The four-digit near number.
+	 *                                            Default empty. Accepts any four-digit year.
+	 *             @type int          'month'     Optional. The two-digit month number.
+	 *                                            Default empty. Accepts numbers 1-12.
+	 *             @type int          'week'      Optional. The week number of the year.
+	 *                                            Default empty. Accepts numbers 0-53.
+	 *             @type int          'day'       Optional. The day of the month.
+	 *                                            Default empty. Accepts numbers 1-31.
+	 *             @type int          'hour'      Optional. The hour of the day.
+	 *                                            Default empty. Accepts numbers 0-23.
+	 *             @type int          'minute'    Optional. The minute of the hour.
+	 *                                            Default empty. Accepts numbers 0-60.
+	 *             @type int          'second'    Optional. The second of the minute.
+	 *                                            Default empty. Accepts numbers 0-60.
+	 *         }
+	 *     }
+	 * }
+	 * @param array $default_column Optional. What column name to query against.
+	 *                              Defaults 'post_date'. Accepts.
 	 */
 	function __construct( $date_query, $default_column = 'post_date' ) {
 		if ( empty( $date_query ) || ! is_array( $date_query ) )
Index: src/wp-includes/meta.php
===================================================================
--- src/wp-includes/meta.php	(revision 25535)
+++ src/wp-includes/meta.php	(working copy)
@@ -610,21 +610,29 @@
  */
 class WP_Meta_Query {
 	/**
-	* List of metadata queries. A single query is an associative array:
-	* - 'key' string The meta key
-	* - 'value' string|array The meta value
-	* - 'compare' (optional) string How to compare the key to the value.
-	*              Possible values: '=', '!=', '>', '>=', '<', '<=', 'LIKE', 'NOT LIKE', 'IN', 'NOT IN',
-	*              'BETWEEN', 'NOT BETWEEN', 'REGEXP', 'NOT REGEXP', 'RLIKE'.
-	*              Default: '='
-	* - 'type' string (optional) The type of the value.
-	*              Possible values: 'NUMERIC', 'BINARY', 'CHAR', 'DATE', 'DATETIME', 'DECIMAL', 'SIGNED', 'TIME', 'UNSIGNED'.
-	*              Default: 'CHAR'
-	*
-	* @since 3.2.0
-	* @access public
-	* @var array
-	*/
+	 * An array of metadata queries.
+	 *
+	 * @type array $queries {
+	 *     One or more associative arrays of meta query parameters.
+	 *
+	 *     @type string 'relation' The boolean relationship between the meta queries.
+	 *                             Default 'AND'. Accepts 'OR', 'AND'.
+	 *     @type array(
+	 *         @type string 'key'     The meta key.
+	 *         @type string 'value'   The meta value.
+	 *         @type string 'compare' Optional. How to compare the key to the value.
+	 *                                Default '='. Accepts '=', '!=', '>', '>=', '<', '<=', 'LIKE',
+	 *                                'NOT LIKE', 'IN', 'NOT IN', 'BETWEEN', 'NOT BETWEEN'.
+	 *         @type string 'type'    Optional. The type of value.
+	 *                                Default 'CHAR'. Accepts 'NUMERIC', 'BINARY', 'CHAR', 'DATE', 'DATETIME',
+	 *                                'DECIMAL', 'SIGNED', 'TIME', 'UNSIGNED'.
+	 *     }
+	 * }
+	 *
+	 * @access public
+	 * @since 3.2.0
+	 * @var array
+	 */
 	public $queries = array();
 
 	/**
@@ -639,7 +647,7 @@
 	/**
 	 * Constructor
 	 *
-	 * @param array $meta_query (optional) A meta query
+	 * @param array $meta_query Optional. A meta query.
 	 */
 	function __construct( $meta_query = false ) {
 		if ( !$meta_query )
Index: src/wp-includes/query.php
===================================================================
--- src/wp-includes/query.php	(revision 25535)
+++ src/wp-includes/query.php	(working copy)
@@ -1430,10 +1430,109 @@
 	/**
 	 * Parse a query string and set query type booleans.
 	 *
+	 * @access public
 	 * @since 1.5.0
-	 * @access public
 	 *
-	 * @param string|array $query Optional query.
+	 * @param string|array $query {
+	 *     Optional. Query parameters.
+	 *
+	 *     @type mixed  'author'                 Author ID, or comma-separated list of IDs.
+	 *     @type string 'author_name'            Use 'user_nicename'.
+	 *     @type array  'author__in'             An array of author IDs to query from.
+	 *     @type array  'author__not_in'         An array of author IDs not to query from.
+	 *     @type array  'tax_query'              An associative array of WP_Tax_Query arguments. @see WP_Tax_Query
+	 *     @type int    'cat'                    Category ID or comma-separated list of IDs (this or any children).
+	 *     @type string 'category_name'          Use category slug (not name, this or any children).
+	 *     @type array  'category__and'          An array of category IDs (AND in).
+	 *     @type array  'category__in'           An array of category IDs (OR in, no children).
+	 *     @type array  'category__not_in'       An array of category IDs (NOT in).
+	 *     @type string 'tag'                    Tag slug. Comma-separated (either), Plus-separated (all).
+	 *     @type int    'tag_id'                 Tag id or comma-separated list of IDs.
+	 *     @type array  'tag__and'               An array of tag ids (AND in).
+	 *     @type array  'tag__in'                An array of tag ids (OR in).
+	 *     @type array  'tag__not_in'            An array of tag ids (NOT in).
+	 *     @type array  'tag_slug__and'          An array of tag slugs (AND in).
+	 *     @type array  'tag_slug__in'           An array of tag slugs (OR in).
+	 *     @type string 's'                      Search keyword.
+	 *     @type bool   'exact'                  Whether to search by exact keyword.
+	 *                                           Default false.
+	 *     @type bool   'sentence'               Whether to search by phrase.
+	 *                                           Default false.
+	 *     @type array  'search_terms'           Array of search terms.
+	 *     @type int    'menu_order'             The menu order of the posts.
+	 *     @type int    'p'                      Post ID.
+	 *     @type string 'name'                   Post slug.
+	 *     @type int    'page_id'                Page ID.
+	 *     @type string 'pagename'               Page slug.
+	 *     @type int    'post_parent'            Page ID to retrieve child pages for. Use 0 to only retrieve top-level pages.
+	 *     @type array  'post_parent__in'        An array containing parent page IDs to query child pages from.
+	 *     @type array  'post_parent__not_in'    An array containing parent page IDs not to query child pages from.
+	 *     @type array  'post__in'               An array of post IDs to retrieve, sticky posts will be included unless
+	 *                                           'ignore_sticky_posts' is true. Note: a string of comma-separated IDs will NOT work.
+	 *     @type array  'post__not_in'           An array of post IDs not to retrieve. Note: a string of comma-separated
+	 *                                           IDs will NOT work.
+	 *     @type mixed  'post_type'              A post type slug (string) or array of post type slugs.
+	 *                                           Default 'any' if using 'tax_query'.
+	 *     @type mixed  'post_status'            A post status (string) or array of post statuses.
+	 *     @type bool   'nopaging'               Show all posts (true) or paginate (false).
+	 *                                           Default false.
+	 *     @type int    'posts_per_page'         The number of posts to query for. Use -1 to request all posts.
+	 *     @type int    'posts_per_archive_page' The number of posts to query for by archive page. Overrides 'posts_per_page'
+	 *                                           when is_archive(), or is_search() are true.
+	 *     @type int    'comments_per_page'      The number of comments to return per page.
+	 *                                           Default 'comments_per_page' option.
+	 *     @type int    'comments_popup'
+	 *                                           Default empty.
+	 *     @type int    'attachment_id'          Attachment post ID. Used for 'attachment' post_type.
+	 *     @type string 'post_mime_type'         The mime type of the post. Used for 'attachment' post_type.
+	 *     @type int    'offset'                 The number of posts to offset before retrieval.
+	 *     @type int    'paged'                  The number of the current page.
+	 *     @type int    'page'                   Show the number of posts that would show up on page X of a static front page.
+	 *     @type bool   'ignore_sticky_posts'    Whether to ignore sticky posts or not. Setting this to false excludes
+	 *                                           stickies from 'post__in'.
+	 *                                           Default 0|false. Accepts 1|true, 0|false.
+	 *     @type string 'order'                  Designates ascending or descending order of posts.
+	 *                                           Default 'DESC'. Accepts 'ASC', 'DESC'.
+	 *     @type string 'orderby'                Sort retrieved posts by parameter. One or more options can be passed.
+	 *                                           To use 'meta_value', or 'meta_value_num', 'meta_key=keyname' must be also be defined.
+	 *                                           Default 'date'. Accepts 'none', 'name', 'author', 'date', 'title', 'modified',
+	 *                                           'menu_order', 'parent', 'ID', 'rand', 'comment_count'.
+	 *     @type array  'date_query'             An associative array of WP_Date_Query arguments. @see WP_Date_Query
+	 *     @type int    'year'                   The four-digit year number.
+	 *                                           Default empty. Accepts any four-digit year.
+	 *     @type int    'monthnum'               The two-digit month number.
+	 *                                           Default empty. Accepts numbers 1-12.
+	 *     @type int    'w'                      The week number of the year.
+	 *                                           Default empty. Accepts numbers 0-53.
+	 *     @type int    'day'                    Day of the month.
+	 *                                           Default empty. Accepts numbers 1-31.
+	 *     @type int    'hour'                   Hour of the day.
+	 *                                           Default empty. Accepts numbers 0-23.
+	 *     @type int    'minute'                 Minute of the hour.
+	 *                                           Default empty. Accepts numbers 0-60.
+	 *     @type int    'second'                 Second of the minute.
+	 *                                           Default empty. Accepts numbers 0-60.
+	 *     @type int    'm'                      Combination YearMonth.
+	 *                                           Default empty. Accepts any four-digit year and month numbers 1-12.
+	 *     @type array  'meta_query'             An associative array of WP_Meta_Query arguments. @see WP_Meta_Query->queries
+	 *     @type string 'meta_key'               Custom field key.
+	 *     @type string 'meta_value'             Custom field value.
+	 *     @type int    'meta_value_num'         Custom field value number.
+	 *     @type string 'meta_compare'           Comparison operator to test the 'meta_value'.
+	 *     @type string 'perm'                   Show posts if user has the appropriate capability.
+	 *     @type bool   'cache_results'          Whether to cache post information.
+	 *                                           Default true.
+	 *     @type bool   'update_post_meta_cache' Whether to update the post meta cache.
+	 *                                           Default true.
+	 *     @type bool   'update_post_term_cache' Whether to update the post term cache.
+	 *                                           Default true.
+	 *     @type bool   'no_found_rows'          Whether to count the total rows found. Disabling can improve performance.
+	 *                                           Default true.
+	 *     @type mixed  'fields'                 Which fields to return. Single field or all fields (string), or array of fields.
+	 *                                           'id=>parent' uses 'id' and 'post_parent'.
+	 *                                           Default all fields. Accepts 'ids', 'id=>parent'.
+	 *     @type bool   'suppress_filters'       Whether to suppress filters.
+	 *                                           Default false.
 	 */
 	function parse_query( $query =  '' ) {
 		if ( ! empty( $query ) ) {
Index: src/wp-includes/taxonomy.php
===================================================================
--- src/wp-includes/taxonomy.php	(revision 25535)
+++ src/wp-includes/taxonomy.php	(working copy)
@@ -584,18 +584,10 @@
 class WP_Tax_Query {
 
 	/**
-	 * List of taxonomy queries. A single taxonomy query is an associative array:
-	 * - 'taxonomy' string The taxonomy being queried
-	 * - 'terms' string|array The list of terms
-	 * - 'field' string (optional) Which term field is being used.
-	 *		Possible values: 'term_id', 'slug' or 'name'
-	 *		Default: 'term_id'
-	 * - 'operator' string (optional)
-	 *		Possible values: 'AND', 'IN' or 'NOT IN'.
-	 *		Default: 'IN'
-	 * - 'include_children' bool (optional) Whether to include child terms.
-	 *		Default: true
+	 * An array of taxonomy queries.
 	 *
+	 * Each taxonomy query is an associative array.
+	 *
 	 * @since 3.1.0
 	 * @access public
 	 * @var array
@@ -628,20 +620,26 @@
 	 * @since 3.1.0
 	 * @access public
 	 *
-	 * @param array $tax_query A compact tax query:
-	 *  array(
-	 *    'relation' => 'OR',
-	 *    array(
-	 *      'taxonomy' => 'tax1',
-	 *      'terms' => array( 'term1', 'term2' ),
-	 *      'field' => 'slug',
-	 *    ),
-	 *    array(
-	 *      'taxonomy' => 'tax2',
-	 *      'terms' => array( 'term-a', 'term-b' ),
-	 *      'field' => 'slug',
-	 *    ),
-	 *  )
+	 * @param array $tax_query {
+	 *     One or more associative arrays of taxonomy query parameters.
+	 *
+	 *     @type array {
+	 *         @type string 'relation' The boolean relationship between the taxonomy queries.
+	 *                                 Default 'OR'. Accepts 'OR', 'AND'.
+	 *         @type array {
+	 *             @type string 'taxonomy'         The taxonomy slug.
+	 *                                             Default empty.
+	 *             @type array  'terms'            An array of taxonomy terms.
+	 *                                             Default empty array.
+	 *             @type bool   'include_children' Whether to include children.
+	 *                                             Default true.
+	 *             @type string 'field'            The type of term field to query.
+	 *                                             Default 'term_id'. Accepts 'term_id', 'slug', 'name', 'term_taxonomy_id'.
+	 *             @type string 'operator'         Description.
+	 *                                             Defailt 'IN'. Accepts 'IN', 'NOT IN', 'AND'.
+	 *         }
+	 *     }
+	 * }
 	 */
 	public function __construct( $tax_query ) {
 		if ( isset( $tax_query['relation'] ) && strtoupper( $tax_query['relation'] ) == 'OR' ) {
@@ -651,11 +649,11 @@
 		}
 
 		$defaults = array(
-			'taxonomy' => '',
-			'terms' => array(),
+			'taxonomy'         => '',
+			'terms'            => array(),
 			'include_children' => true,
-			'field' => 'term_id',
-			'operator' => 'IN',
+			'field'            => 'term_id',
+			'operator'         => 'IN',
 		);
 
 		foreach ( $tax_query as $query ) {